<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>7.1 Assignment Operators</title>
<link href="sx7.html" rev=precedes>
<link href="sx7b.html" rel=precedes>
<link href="sx7.html" rev=subdocument>
</head>
<body>
<H2>7.1 Assignment Operators</H2>

<p>[This section corresponds to K&amp;R Sec. 2.10]
</p><p>The first and more general way is that any time you have the 
pattern
<pre>
	<I>v</I> = <I>v</I> <I>op</I> <I>e</I>
</pre>
where <I>v</I> is any variable
(or anything like <TT>a[i]</TT>),
<I>op</I> is any of the binary arithmetic operators we've seen so far,

and <I>e</I> is any expression,
you can replace it with the simplified
<pre>
	<I>v</I> <I>op</I>= <I>e</I>
</pre>
For example, you can replace the expressions
<pre>
	i = i + 1
	j = j - 10
	k = k * (n + 1)
	a[i] = a[i] / b
</pre>
with
<pre>
	i += 1
	j -= 10
	k *= n + 1
	a[i] /= b
</pre>
</p><p>In an example in a previous chapter,
we used the assignment
<pre>
	a[d1 + d2] = a[d1 + d2] + 1;
</pre>
to count the rolls of a pair of dice.
Using <TT>+=</TT>, we could simplify this expression to
<pre>
	a[d1 + d2] += 1;
</pre>
</p><p>As these examples show,
you can
use the ``op='' form
with any of the arithmetic operators
(and with several other operators that we haven't seen yet).
The expression, <I>e</I>,
does not have to be the constant 1;
it can be any expression.
You don't always need as many explicit parentheses
when using the <I>op</I><TT>=</TT> operators:
the expression
<pre>
	k *= n + 1
</pre>
is interpreted as
<pre>
	k = k * (n + 1)
</pre>

</p><hr>
<p>
Read sequentially:
<a href="sx7.html" rev=precedes>prev</a>
<a href="sx7b.html" rel=precedes>next</a>
<a href="sx7.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
